DROP PROCEDURE ADD_REM_CONTACT;

CREATE PROCEDURE ADD_REM_CONTACT (
    USERS_ID INTEGER,
    DOCUMENT_ID INTEGER,
    CONTACT_TYPE_ID INTEGER,
    PERSON_ID INTEGER,
    CONTACT_RESULT_ID INTEGER,
    DT_CONTACT TIMESTAMP,
    COMMENTS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ACCESS INTEGER)
RETURNS (
    CONTACT_FINAL_ID INTEGER,
    ERROR INTEGER)
AS
BEGIN
/*
ERROR :
    0 - 
    1 -     
*/
    IF (EXISTS (SELECT
                    PERSON.USERS_ID
                FROM
                    PERSON
                WHERE
                (PERSON.ID =:PERSON_ID) AND
                (PERSON.USERS_ID =:USERS_ID)))
    THEN
        BEGIN
            ERROR = 0;
        END
    ELSE
    IF (ACCESS <> 0)
    THEN
        ERROR = 0;
    ELSE
        ERROR = 1;


    IF (ERROR = 0)
    THEN
        BEGIN
            CONTACT_FINAL_ID = GEN_ID(GEN_CONTACT_ID, 1);

            INSERT INTO CONTACT (
                ID,
                PERSON_ID,
                CONTACT_TYPE_ID,
                DOCUMENT_ID,
                CONTACT_RESULT_ID,
                USERS_ID,
                DT_CONTACT,
                COMMENTS
            )
            VALUES (
                :CONTACT_FINAL_ID,
                :PERSON_ID,
                :CONTACT_TYPE_ID,
                :DOCUMENT_ID,
                :CONTACT_RESULT_ID,
                :USERS_ID,
                :DT_CONTACT,
                :COMMENTS
            );
        END

  SUSPEND;
END