ALTER PROCEDURE CLEAR_EDIT_USERS_ID (
    ID INTEGER,
    IN_OUT INTEGER,
    PROGRAM_ID INTEGER)
AS
BEGIN
  UPDATE SPAM
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE PROJECTS_STATUS_MAIN
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE REMINDER
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    PROJECTS
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    PROJECTS_STATUS
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    EVENT_PROJECTS
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    DOCUMENT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    DOCUMENT_TYPE
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    NOMENCLATURE
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    NOMENCLATURE_NUMBERS
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ORGANIZATION
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    REGION
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    COUNTRY
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    TREND
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    CITY
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    PERSON
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    JOB_STATUS
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    CONTACT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    CONTACT_TYPE
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ACTIVITY
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    TASK
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ORGANIZATION_GROUP
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    CONTACT_RESULT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ORGANIZATION_TYPE
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ORGANIZATION_SOURCE
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ACTIONS
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  IF (IN_OUT = 1)
  THEN
    BEGIN
      UPDATE
        PROGRAM
      SET
        USERS_ID = NULL
      WHERE
        (USERS_ID IS NOT NULL) AND ((:ID = -1) or (USERS_ID = :ID));
    END
  ELSE
    BEGIN
      UPDATE
        PROGRAM
      SET
        USERS_ID = :ID
      WHERE
        ID = :PROGRAM_ID;
    END

  UPDATE
    ORGANIZATION_DISCOUNT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    NOMENCLATURE_GROUP
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    CURRENCY
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ED
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    PAKAGE
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    CITY_DIRECT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    SMS_SPAM
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    EVENT_PROJECTS_SOURCE_PAY
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ACCOUNT_GROUP
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    ACCOUNT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    BUH_ACCOUNT
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));

  UPDATE
    BUH_HOLIDAY
  SET
    EDIT_USERS_ID = NULL
  WHERE
    (EDIT_USERS_ID IS NOT NULL) AND ((:ID = -1) or (EDIT_USERS_ID = :ID));
END;

CREATE GENERATOR GEN_SETTINGS_PRIORITY_ID;

CREATE TABLE SETTINGS_PRIORITY (
    ID                  INTEGER NOT NULL,
    PRIORITY_CAPTION    VARCHAR(32) NOT NULL,
    X                   INTEGER NOT NULL,
    Y                   INTEGER NOT NULL,
    DAYS_REMINDER       INTEGER NOT NULL,
    TIME_REMINDER_ON    INTEGER NOT NULL,
    TIME_REMINDER       TIMESTAMP NOT NULL,
    PRIORITY_REMINDER   INTEGER NOT NULL,
    START_ONLY_ORG_REM  INTEGER NOT NULL,
    USERS_ID            INTEGER NOT NULL
);

ALTER TABLE SETTINGS_PRIORITY ADD CONSTRAINT PK_SETTINGS_PRIORITY PRIMARY KEY (ID);
ALTER TABLE SETTINGS_PRIORITY ADD CONSTRAINT FK_SETTINGS_PRIORITY_1 FOREIGN KEY (USERS_ID) REFERENCES USERS (ID) ON DELETE CASCADE;

CREATE TRIGGER SETTINGS_PRIORITY_BI FOR SETTINGS_PRIORITY
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL)
  THEN
    NEW.ID = GEN_ID(GEN_SETTINGS_PRIORITY_ID,1);
END;

EXECUTE PROCEDURE SET_VERSION('3.1.49');