ALTER TABLE CONTACT ADD NOMENCLATURE_ID INTEGER;

ALTER TABLE CONTACT ADD CONSTRAINT FK_CONTACT_3 FOREIGN KEY (NOMENCLATURE_ID) REFERENCES NOMENCLATURE (ID) ON DELETE SET NULL;

CREATE OR ALTER TRIGGER CONTACT_BI FOR CONTACT
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN

  IF (NEW.ID IS NULL)
  THEN
    NEW.ID = GEN_ID(GEN_CONTACT_ID, 1);

  IF (NEW.NOMENCLATURE_ID < 1)
  THEN
    NEW.NOMENCLATURE_ID = NULL;

  NEW.DOCUMENT_COUNT = 0;

END;

CREATE OR ALTER TRIGGER CONTACT_BU FOR CONTACT
ACTIVE BEFORE UPDATE POSITION 0
AS
begin

  IF (NEW.NOMENCLATURE_ID < 1)
  THEN
    NEW.NOMENCLATURE_ID = NULL;

end;
