CREATE OR ALTER procedure GET_REMINDER (
    DT timestamp,
    USERS_ID integer)
returns (
    NEW_COUNT integer,
    REM_COUNT integer,
    ID integer)
as
BEGIN

  REM_COUNT = 0;
  SELECT
    COUNT (REMINDER.ID)
  FROM
    REMINDER
  WHERE
    (REMINDER.TO_USERS_ID =: USERS_ID) AND
    (REMINDER.DT_REMINDER <= :DT) AND
    (REMINDER.STATUS IN (0,1))
  INTO
    :NEW_COUNT;

  IF (NEW_COUNT <> 0)
  THEN
    UPDATE REMINDER
    SET
        REMINDER.STATUS = 2   /*  */
    WHERE
    (REMINDER.TO_USERS_ID =: USERS_ID) AND
    (REMINDER.DT_REMINDER <= :DT) AND
    (REMINDER.STATUS IN (0,1)) AND
    (REMINDER.EDIT_USERS_ID IS NULL);

  REM_COUNT = 0 ;
  SELECT
    COUNT (REMINDER.ID)
  FROM
    REMINDER
  WHERE
    (REMINDER.TO_USERS_ID =: USERS_ID) AND
    (REMINDER.DT_REMINDER <= :DT) AND
    (REMINDER.STATUS = 2)
  INTO
    :REM_COUNT;

  ID = 0;
  SELECT
    REMINDER.ID
  FROM
    REMINDER
  WHERE
    (REMINDER.TO_USERS_ID =: USERS_ID) AND
    (REMINDER.DT_REMINDER <= :DT) AND
    (REMINDER.STATUS = 2) AND
    (REMINDER.PRIORITY = 3)
  INTO
    :ID;

  SUSPEND;
END;

EXECUTE PROCEDURE SET_VERSION('3.1.35');