ALTER TABLE USERS ADD ORG_COMMENTS BLOB SUB_TYPE 1 SEGMENT SIZE 80 CHARACTER SET WIN1251;

CREATE OR ALTER procedure ADD_USER (
    DEPARTMENT_ID integer,
    LOGIN varchar(16),
    PASSW varchar(40),
    FIO varchar(128),
    JOBTITLE varchar(128),
    DIRECTORY varchar(256),
    GRANTS blob sub_type 1 segment size 80,
    CONFIG blob sub_type 1 segment size 80,
    COMMENTS blob sub_type 1 segment size 80,
    ORG_COMMENTS blob sub_type 1 segment size 80)
returns (
    ID integer)
as
BEGIN


  ID = GEN_ID(GEN_USERS_ID, 1);

    INSERT INTO USERS
    (ID,
     DEPARTMENT_ID,
     LOGIN,
     PASSW,
     FIO, 
     JOBTITLE,
     GRANTS,
     CONFIG,
     COMMENTS,
     ORG_COMMENTS,
     DIRECTORY
     )
  VALUES
    (:ID,
     :DEPARTMENT_ID,
     :LOGIN,
     :PASSW,
     :FIO,
     :JOBTITLE,
     :GRANTS,
     :CONFIG,
     :COMMENTS,
     :ORG_COMMENTS,
     :DIRECTORY
     );


  SUSPEND;
END;

EXECUTE PROCEDURE SET_VERSION('3.1.46.2');